Index: api/src/main/java/org/hippoecm/frontend/util/CodecUtils.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- api/src/main/java/org/hippoecm/frontend/util/CodecUtils.java	(revision )
+++ api/src/main/java/org/hippoecm/frontend/util/CodecUtils.java	(revision )
@@ -0,0 +1,167 @@
+/*
+ *  Copyright 2014 Hippo B.V. (http://www.onehippo.com)
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *       http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.hippoecm.frontend.util;
+
+import javax.jcr.Node;
+import javax.jcr.RepositoryException;
+
+import org.apache.wicket.model.IModel;
+import org.apache.wicket.model.LoadableDetachableModel;
+import org.hippoecm.frontend.plugin.IPluginContext;
+import org.hippoecm.frontend.service.ISettingsService;
+import org.hippoecm.repository.api.HippoNodeType;
+import org.hippoecm.repository.api.StringCodec;
+import org.hippoecm.repository.api.StringCodecFactory;
+import org.hippoecm.repository.translation.HippoTranslationNodeType;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class CodecUtils {
+    public static final Logger log = LoggerFactory.getLogger(CodecUtils.class);
+
+    public static final String ENCODING_NODE    = "encoding.node";
+    public static final String ENCODING_DISPLAY = "encoding.display";
+
+    /**
+     * Return a {@link StringCodecFactory} from the {@link ISettingsService} or throw an {@link IllegalStateException} 
+     * if not found.
+     * 
+     * @param context The {@link IPluginContext} should contain a reference to the {@link ISettingsService}, otherwise
+     *                an {@link IllegalStateException} is thrown.
+     * @return a {@link StringCodecFactory} if found, otherwise an {@link IllegalStateException} is thrown.
+     */
+    public static StringCodecFactory getStringCodecFactory(final IPluginContext context) {
+        ISettingsService settingsService = context.getService(ISettingsService.SERVICE_ID, ISettingsService.class);
+        if (settingsService == null) {
+            throw new IllegalStateException("ISettingsService not found.");
+        }
+        
+        StringCodecFactory factory = settingsService.getStringCodecFactory();
+        if (factory == null) {
+            throw new IllegalStateException("StringCodecFactory not found.");
+        }
+
+        return factory;
+    }
+
+    /**
+     * Lookup a {@link StringCodec} for encoding/decoding a display name.
+     * 
+     * @param context Used for retrieving the {@link StringCodecFactory}, see {@link #getStringCodecFactory}
+     * @return a {@link StringCodec} for encoding/decoding a display name.
+     */
+    public static StringCodec getDisplayNameCodec(final IPluginContext context) {
+        //TODO: remove the null and revert to default single arg implementation
+        return getStringCodecFactory(context).getStringCodec(ENCODING_DISPLAY, null);
+    }
+
+    /**
+     * Lookup a {@link StringCodec} for encoding/decoding a node name for a specific locale (optional).
+     *
+     * @param context Used for retrieving the {@link StringCodecFactory}, see {@link #getStringCodecFactory}
+     * @param locale Simplified string representation of a locale like <em>en_US</em> or <em>de</em>
+     * @return a {@link StringCodec} for encoding/decoding a node name.
+     */
+    public static StringCodec getNodeNameCodec(final IPluginContext context, final String locale) {
+        return getStringCodecFactory(context).getStringCodec(ENCODING_NODE, locale); 
+    }
+
+    /**
+     * Lookup a {@link StringCodec} for encoding/decoding a node name. The {@link Node} is used for retrieving an 
+     * optional locale.
+     * 
+     * @param context Used for retrieving the {@link StringCodecFactory}, see {@link #getStringCodecFactory}
+     * @param node If the node or any of its parents have property {@link HippoTranslationNodeType#LOCALE} set, the 
+     *             value is used to localize the {@link StringCodec}. 
+     * @return a {@link StringCodec} for encoding/decoding a node name. 
+     */
+    public static StringCodec getNodeNameCodec(final IPluginContext context, final Node node) {
+        final String locale = getLocaleFromNodeAndAncestors(node);
+        return getNodeNameCodec(context, locale);
+    }
+
+    /**
+     * Convenience method for wrapping a {@link StringCodec} in a {@link LoadableDetachableModel}. See 
+     * {@link #getNodeNameCodec(IPluginContext, String)}
+     *
+     * @param context Used for retrieving the {@link StringCodecFactory}, see {@link #getStringCodecFactory}
+     * @param locale Simplified string representation of a locale like <em>en_US</em> or <em>de</em>
+     * @return A {@link LoadableDetachableModel} wrapping a {@link StringCodec} for encoding/decoding a node name.
+     */
+    public static IModel<StringCodec> getNodeNameCodecModel(final IPluginContext context, final String locale) {
+        return new LoadableDetachableModel<StringCodec>() {
+            @Override
+            protected StringCodec load() {
+                return getNodeNameCodec(context, locale);
+            }
+        };
+    }
+
+    /**
+     * Return the value of property {@link HippoTranslationNodeType#LOCALE} for the first translated node found. If
+     * the provided node is of type <code>hippo:translated</code> and is a handle, start with the first child. 
+     * Traverse up the ancestor tree until a locale is found.
+     * 
+     * @param node Node to start traversal with
+     * @return String representation of locale associated with subtree
+     */
+    public static String getLocaleFromNodeAndAncestors(Node node) {
+        try {
+            if (node.isNodeType(HippoNodeType.NT_TRANSLATED) && node.hasNode(node.getName())) {
+                node = node.getNode(node.getName());
+            }
+
+            while (node != null && node.getDepth() > 0) {
+                if (node.isNodeType(HippoTranslationNodeType.NT_TRANSLATED)) {
+                    return node.getProperty(HippoTranslationNodeType.LOCALE).getString();
+                }
+                node = node.getParent();
+            }
+        } catch (RepositoryException e) {
+            log.error("Could not determine visibility of language field");
+        }
+
+        return null;
+    }
+
+    public static String getLocaleFromNode(Node node) {
+        try {
+            if (node.isNodeType(HippoNodeType.NT_TRANSLATED) && node.hasNode(node.getName())) {
+                node = node.getNode(node.getName());
+            }
+
+            if (node.isNodeType(HippoTranslationNodeType.NT_TRANSLATED)) {
+                return node.getProperty(HippoTranslationNodeType.LOCALE).getString();
+            }
+        } catch (RepositoryException e) {
+            log.error("Could not determine visibility of language field");
+        }
+
+        return null;
+    }
+
+    /**
+     * Helper method for fetching a locale for a document or a folder.
+     */
+    public static String getLocaleFromDocumentOrFolder(final Node document, final Node folder) {
+        String locale = CodecUtils.getLocaleFromNode(document);
+        if (locale == null) {
+            // otherwise use locale of folder
+            locale = CodecUtils.getLocaleFromNodeAndAncestors(folder);
+        }
+        return locale;
+    }
+}
Index: workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/DocumentWorkflowPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/DocumentWorkflowPlugin.java	(revision 48312)
+++ workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/DocumentWorkflowPlugin.java	(revision )
@@ -23,11 +23,13 @@
 import javax.jcr.Node;
 import javax.jcr.RepositoryException;
 
+import org.apache.wicket.model.AbstractReadOnlyModel;
 import org.apache.wicket.model.IModel;
 import org.apache.wicket.model.PropertyModel;
 import org.apache.wicket.model.StringResourceModel;
 import org.apache.wicket.request.resource.PackageResourceReference;
 import org.apache.wicket.request.resource.ResourceReference;
+import org.apache.wicket.util.string.Strings;
 import org.hippoecm.addon.workflow.DestinationDialog;
 import org.hippoecm.addon.workflow.StdWorkflow;
 import org.hippoecm.addon.workflow.WorkflowDescriptorModel;
@@ -42,6 +44,7 @@
 import org.hippoecm.frontend.plugin.config.IPluginConfig;
 import org.hippoecm.frontend.plugins.reviewedactions.dialogs.HistoryDialog;
 import org.hippoecm.frontend.session.UserSession;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.repository.api.Document;
 import org.hippoecm.repository.api.HippoNode;
 import org.hippoecm.repository.api.Localized;
@@ -96,8 +99,10 @@
 
             @Override
             protected IDialogService.Dialog createRequestDialog() {
+                String locale = null;
                 try {
                     final HippoNode node = getModelNode();
+                    locale = CodecUtils.getLocaleFromNodeAndAncestors(node);
                     uriName = node.getName();
                     targetName = getLocalizedNameForSession(node);
                     localizedNames = node.getLocalizedNames();
@@ -105,14 +110,15 @@
                     uriName = targetName = "";
                     localizedNames = Collections.emptyMap();
                 }
+
+                IModel<StringCodec> codecModel = CodecUtils.getNodeNameCodecModel(context, locale);
                 return new RenameDocumentDialog(this,
                         new StringResourceModel("rename-title", DocumentWorkflowPlugin.this, null),
-                        context);
+                        codecModel);
             }
 
             private HippoNode getModelNode() throws RepositoryException {
-                final WorkflowDescriptorModel model = (WorkflowDescriptorModel) getDefaultModel();
-                return (HippoNode) model.getNode();
+                return (HippoNode) getModel().getNode();
             }
 
             private String getLocalizedNameForSession(final HippoNode node) throws RepositoryException {
@@ -123,15 +129,21 @@
 
             @Override
             protected String execute(Workflow wf) throws Exception {
-                if (targetName == null || targetName.trim().equals("")) {
-                    throw new WorkflowException("No name for destination given");
+                if (Strings.isEmpty(targetName)) {
+                    throw new WorkflowException("No name given for document node");
                 }
+                if (Strings.isEmpty(uriName)) {
+                    throw new WorkflowException("No URL name given for document node");
+                }
+
                 final HippoNode node = getModelNode();
-                String nodeName = getNodeNameCodec().encode(uriName);
+                String nodeName = getNodeNameCodec(node).encode(uriName);
                 String localName = getLocalizeCodec().encode(targetName);
-                if ("".equals(nodeName)) {
+
+                if (Strings.isEmpty(nodeName)) {
                     throw new IllegalArgumentException("You need to enter a name");
                 }
+
                 WorkflowManager manager = UserSession.get().getWorkflowManager();
                 DefaultWorkflow defaultWorkflow = (DefaultWorkflow) manager.getWorkflow("core", node);
                 if (!((WorkflowDescriptorModel) getDefaultModel()).getNode().getName().equals(nodeName)) {
@@ -165,11 +177,23 @@
             @Override
             protected IDialogService.Dialog createRequestDialog() {
                 destination = new NodeModelWrapper(getFolder()) {};
-                CopyNameHelper copyNameHelper = new CopyNameHelper(getNodeNameCodec(), new StringResourceModel(
-                        "copyof", DocumentWorkflowPlugin.this, null).getString());
+
                 try {
-                    name = copyNameHelper.getCopyName(((HippoNode) ((WorkflowDescriptorModel) getDefaultModel())
-                            .getNode()).getLocalizedName(), destination.getNodeModel().getNode());
+                    IModel<StringCodec> codec = new AbstractReadOnlyModel<StringCodec>() {
+                        @Override
+                        public StringCodec getObject() {
+                            try {
+                                return getNodeNameCodec(getModelNode(), getFolder().getNode());
+                            } catch (RepositoryException e) {
+                                return getNodeNameCodec(getFolder().getNode());
+                            }
+                        }
+                    };
+
+                    final CopyNameHelper copyNameHelper = new CopyNameHelper(codec,
+                            new StringResourceModel("copyof", DocumentWorkflowPlugin.this, null).getString());
+                    name = copyNameHelper.getCopyName(getModelNode().getLocalizedName(),
+                            destination.getNodeModel().getNode());
                 } catch (RepositoryException ex) {
                     return new ExceptionDialog(ex);
                 }
@@ -196,18 +220,15 @@
 
             @Override
             protected String execute(Workflow wf) throws Exception {
-                JcrNodeModel folderModel;
-                if (destination != null) {
-                    folderModel = destination.getNodeModel();
-                } else {
-                    folderModel = new JcrNodeModel("/");
-                }
-                StringCodec codec = getNodeNameCodec();
-                String nodeName = codec.encode(name);
+                Node folder = destination != null ? destination.getNodeModel().getNode() : new JcrNodeModel("/").getNode();
+                Node document = getModel().getNode();
+
+                String nodeName = getNodeNameCodec(document, folder).encode(name);
+
                 DocumentWorkflow workflow = (DocumentWorkflow) wf;
+                workflow.copy(new Document(folder), nodeName);
 
-                workflow.copy(new Document(folderModel.getNode()), nodeName);
-                JcrNodeModel resultModel = new JcrNodeModel(folderModel.getItemModel().getPath() + "/" + nodeName);
+                JcrNodeModel resultModel = new JcrNodeModel(folder.getPath() + "/" + nodeName);
                 Node result = resultModel.getNode();
 
                 WorkflowManager manager = UserSession.get().getWorkflowManager();
@@ -217,6 +238,11 @@
                 browseTo(resultModel);
                 return null;
             }
+
+            private HippoNode getModelNode() throws RepositoryException {
+                return (HippoNode) getModel().getNode();
+            }
+
         });
 
         add(moveAction = new StdWorkflow("move", new StringResourceModel("move-label", this, null), context, getModel()) {
@@ -266,14 +292,14 @@
 
             @Override
             protected String execute(Workflow wf) throws Exception {
-                JcrNodeModel folderModel = new JcrNodeModel("/");
-                if (destination != null) {
-                    folderModel = destination.getNodeModel();
-                }
-                String nodeName = getModel().getNode().getName();
+                Node document = getModel().getNode();
+                Node folder = destination != null ? destination.getNodeModel().getObject()
+                        : new JcrNodeModel("/").getNode();
+
+                String nodeName = document.getName();
                 DocumentWorkflow workflow = (DocumentWorkflow) wf;
-                workflow.move(new Document(folderModel.getNode()), nodeName);
-                browseTo(new JcrNodeModel(folderModel.getItemModel().getPath() + "/" + nodeName));
+                workflow.move(new Document(folder), nodeName);
+                browseTo(new JcrNodeModel(folder.getPath() + "/" + nodeName));
                 return null;
             }
         });
@@ -422,6 +448,16 @@
 
         hideOrDisable(info, "copy", copyAction);
         hideOrDisable(info, "listVersions", historyAction);
+    }
+
+    /**
+     * Helper method for fetching a StringCodec for a document. If document has a locale, use it to find a fitting
+     * {@link StringCodec}, otherwise search the destination tree for a locale and use that to find a fitting
+     * {@link StringCodec}.
+     */
+    private StringCodec getNodeNameCodec(final Node document, final Node destination) {
+        String locale = CodecUtils.getLocaleFromDocumentOrFolder(document, destination);
+        return CodecUtils.getNodeNameCodec(getPluginContext(), locale);
     }
 
     private static boolean isWritePermissionGranted(IModel<Node> model) {
Index: gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/upload/UploadDialog.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/upload/UploadDialog.java	(revision 48312)
+++ gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/upload/UploadDialog.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2008-2013 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2008-2015 Hippo B.V. (http://www.onehippo.com)
  * 
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -19,7 +19,6 @@
 import javax.jcr.PathNotFoundException;
 import javax.jcr.RepositoryException;
 
-import org.apache.wicket.Session;
 import org.apache.wicket.extensions.wizard.IWizardModel;
 import org.apache.wicket.model.IModel;
 import org.apache.wicket.model.StringResourceModel;
@@ -28,20 +27,18 @@
 import org.hippoecm.frontend.model.JcrNodeModel;
 import org.hippoecm.frontend.plugin.IPluginContext;
 import org.hippoecm.frontend.plugin.config.IPluginConfig;
-import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.frontend.session.UserSession;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.repository.api.StringCodec;
-import org.hippoecm.repository.api.StringCodecFactory;
 import org.hippoecm.repository.api.Workflow;
 import org.hippoecm.repository.api.WorkflowManager;
 import org.hippoecm.repository.gallery.GalleryWorkflow;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
-public class UploadDialog extends AbstractDialog {
+public class UploadDialog extends AbstractDialog<Node> {
     private static final long serialVersionUID = 1L;
 
-
     static final Logger log = LoggerFactory.getLogger(UploadDialog.class);
 
     UploadWizard wizard;
@@ -52,7 +49,7 @@
         this(context, config, null);
     }
 
-    public UploadDialog(IPluginContext context, IPluginConfig config, IModel model) {
+    public UploadDialog(IPluginContext context, IPluginConfig config, IModel<Node> model) {
         super(model);
         setOkVisible(false);
         setCancelVisible(false);
@@ -68,29 +65,22 @@
     }
 
     String getWorkflowCategory() {
-        String workflowCats = pluginConfig.getString("workflow.categories");
-        return workflowCats;
+        return pluginConfig.getString("workflow.categories");
     }
 
     protected StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = pluginContext
-                .getService(ISettingsService.SERVICE_ID, ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(pluginContext);
     }
 
-    protected StringCodec getNodeNameCodec() {
-        ISettingsService settingsService = pluginContext
-                .getService(ISettingsService.SERVICE_ID, ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.node");
+    protected StringCodec getNodeNameCodec(Node node) {
+        return CodecUtils.getNodeNameCodec(pluginContext, node);
     }
 
     IWizardModel getWizardModel() {
         return wizard.getWizardModel();
     }
 
-    public IModel getTitle() {
+    public IModel<String> getTitle() {
         return new StringResourceModel(pluginConfig.getString("option.text", ""), this, null);
     }
 
@@ -99,14 +89,13 @@
     }
 
     Node getGalleryNode() {
-        Object modelObject = getModelObject();
-        Node node = null;
+        Node galleryNode = getModelObject();
         try {
-            if (modelObject != null && modelObject instanceof Node) {
+            if (galleryNode != null) {
                 WorkflowManager manager = UserSession.get().getWorkflowManager();
-                Workflow workflow = manager.getWorkflow(getWorkflowCategory(), (Node) modelObject);
+                Workflow workflow = manager.getWorkflow(getWorkflowCategory(), galleryNode);
                 if (workflow instanceof GalleryWorkflow) {
-                    return (Node) modelObject;
+                    return galleryNode;
                 }
             }
             String location = pluginConfig.getString("option.location");
@@ -116,7 +105,10 @@
                 }
                 javax.jcr.Session jcrSession = UserSession.get().getJcrSession();
                 if (jcrSession.getRootNode().hasNode(location)) {
-                    node = jcrSession.getRootNode().getNode(location);
+                    return jcrSession.getRootNode().getNode(location);
+                } else {
+                    log.warn("Failed to retrieve gallery node from configuration using option.location={}",
+                            pluginConfig.getString("option.location"));
                 }
             }
         } catch (PathNotFoundException e) {
@@ -124,6 +116,6 @@
         } catch (RepositoryException e) {
             log.error("Error while accessing upload directory " + e.getMessage());
         }
-        return node;
+        return null;
     }
 }
Index: workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/AbstractDocumentWorkflowPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/AbstractDocumentWorkflowPlugin.java	(revision 48312)
+++ workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/AbstractDocumentWorkflowPlugin.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2014 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2015 Hippo B.V. (http://www.onehippo.com)
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -35,12 +35,11 @@
 import org.hippoecm.frontend.plugin.config.IPluginConfig;
 import org.hippoecm.frontend.service.IBrowseService;
 import org.hippoecm.frontend.service.IEditorManager;
-import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.frontend.service.render.RenderPlugin;
 import org.hippoecm.frontend.session.UserSession;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.repository.HippoStdNodeType;
 import org.hippoecm.repository.api.StringCodec;
-import org.hippoecm.repository.api.StringCodecFactory;
 import org.hippoecm.repository.api.WorkflowException;
 import org.hippoecm.repository.util.NodeIterable;
 import org.onehippo.repository.documentworkflow.DocumentWorkflow;
@@ -90,17 +89,11 @@
     }
 
     protected StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(getPluginContext());
     }
 
-    protected StringCodec getNodeNameCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.node");
+    protected StringCodec getNodeNameCodec(final Node node) {
+        return CodecUtils.getNodeNameCodec(getPluginContext(), node);
     }
 
     protected void hideOrDisable(Map<String, Serializable> info, String key, StdWorkflow... actions) {
Index: translation/frontend/src/main/java/org/hippoecm/frontend/translation/workflow/DocumentTranslationDialog.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- translation/frontend/src/main/java/org/hippoecm/frontend/translation/workflow/DocumentTranslationDialog.java	(revision 48312)
+++ translation/frontend/src/main/java/org/hippoecm/frontend/translation/workflow/DocumentTranslationDialog.java	(revision )
@@ -28,6 +28,7 @@
 import org.hippoecm.frontend.translation.ILocaleProvider;
 import org.hippoecm.frontend.translation.components.document.DocumentTranslationView;
 import org.hippoecm.frontend.translation.components.document.FolderTranslation;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.frontend.widgets.BooleanFieldWidget;
 import org.hippoecm.repository.api.StringCodec;
 import org.hippoecm.repository.api.StringCodecFactory;
@@ -41,7 +42,7 @@
 
     public DocumentTranslationDialog(ISettingsService settings,
             IWorkflowInvoker action, IModel<String> title, List<FolderTranslation> folders, IModel<Boolean> autoTranslateContent,
-            String sourceLanguage, String targetLanguage,
+            String sourceLanguage, final String targetLanguage,
             ILocaleProvider provider) {
         super(null, action);
         this.settingsService = settings;
@@ -55,7 +56,7 @@
                     @Override
                     protected StringCodec load() {
                         StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-                        return stringCodecFactory.getStringCodec("encoding.node");
+                        return stringCodecFactory.getStringCodec(CodecUtils.ENCODING_NODE, targetLanguage);
                     }
                 }, provider);
         dtv.setFrame(false);
@@ -67,7 +68,7 @@
         }
     }
 
-    public IModel getTitle() {
+    public IModel<String> getTitle() {
         return title;
     }
 
Index: gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/upload/UploadForm.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/upload/UploadForm.java	(revision 48312)
+++ gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/upload/UploadForm.java	(revision )
@@ -41,7 +41,6 @@
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.repository.api.Document;
 import org.hippoecm.repository.api.HippoNode;
-import org.hippoecm.repository.api.MappingException;
 import org.hippoecm.repository.api.WorkflowException;
 import org.hippoecm.repository.api.WorkflowManager;
 import org.hippoecm.repository.gallery.GalleryWorkflow;
@@ -49,7 +48,7 @@
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
-class UploadForm extends Form {
+class UploadForm extends Form<Node> {
 
     private static final long serialVersionUID = 1L;
 
@@ -83,17 +82,13 @@
                 } else {
                     galleryTypes = workflow.getGalleryTypes();
                 }
-            } catch (MappingException ex) {
+            } catch (RemoteException | RepositoryException ex) {
                 log.error(ex.getMessage(), ex);
-            } catch (RepositoryException ex) {
-                log.error(ex.getMessage(), ex);
-            } catch (RemoteException ex) {
-                log.error(ex.getMessage(), ex);
             }
             if (galleryTypes != null && galleryTypes.size() > 1) {
                 DropDownChoice folderChoice;
                 type = galleryTypes.get(0);
-                add(folderChoice = new DropDownChoice("type", new PropertyModel(this, "type"), galleryTypes,
+                add(folderChoice = new DropDownChoice<>("type", new PropertyModel<String>(this, "type"), galleryTypes,
                         new TypeChoiceRenderer(this)));
                 folderChoice.setNullValid(false);
                 folderChoice.setRequired(true);
@@ -144,24 +139,18 @@
                     Node galleryNode = uploadDialog.getGalleryNode();
                     GalleryWorkflow workflow = (GalleryWorkflow) manager.getWorkflow(this.uploadDialog
                             .getWorkflowCategory(), galleryNode);
-                    String nodeName = uploadDialog.getNodeNameCodec().encode(filename);
+                    String nodeName = uploadDialog.getNodeNameCodec(galleryNode).encode(filename);
                     String localName = uploadDialog.getLocalizeCodec().encode(filename);
                     Document document = workflow.createGalleryItem(nodeName, type);
-                    node = (HippoNode) UserSession.get().getJcrSession().getNodeByUUID(
+                    node = (HippoNode) UserSession.get().getJcrSession().getNodeByIdentifier(
                             document.getIdentity());
                     DefaultWorkflow defaultWorkflow = (DefaultWorkflow) manager.getWorkflow("core", node);
                     if (!node.getLocalizedName().equals(localName)) {
                         defaultWorkflow.localizeName(localName);
                     }
-                } catch (WorkflowException ex) {
+                } catch (WorkflowException | RepositoryException ex) {
                     log.error(ex.getMessage());
                     error(ex);
-                } catch (MappingException ex) {
-                    log.error(ex.getMessage());
-                    error(ex);
-                } catch (RepositoryException ex) {
-                    log.error(ex.getMessage());
-                    error(ex);
                 }
                 if (node != null) {
                     try {
@@ -179,11 +168,7 @@
                         try {
                             DefaultWorkflow defaultWorkflow = (DefaultWorkflow) manager.getWorkflow("core", node);
                             defaultWorkflow.delete();
-                        } catch (WorkflowException e) {
-                            log.error(e.getMessage());
-                        } catch (MappingException e) {
-                            log.error(e.getMessage());
-                        } catch (RepositoryException e) {
+                        } catch (WorkflowException | RepositoryException e) {
                             log.error(e.getMessage());
                         }
                         try {
